﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.DataPresenter;
using Infragistics.Windows.Editors;

namespace XamDataGridDynamicColumns
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        public StaffMemberViewModel ViewModel
        {
            get { return this.DataContext as StaffMemberViewModel; }
        }

        private void xamDataGrid_FieldLayoutInitialized(object sender, Infragistics.Windows.DataPresenter.Events.FieldLayoutInitializedEventArgs e)
        {
            //a cheat to get the number of columns to create.
            var staffMember = this.ViewModel.StaffMembers.First();

            for (Int32 i = 0; i < staffMember.Periods.Count; i++)
            {
                var field = new UnboundField
                {
                    Name = staffMember.Periods[i].Title,
                    BindingMode = BindingMode.TwoWay,
                    BindingPath = new PropertyPath(String.Format("Periods[{0}].Hours", i))
                };

                field.DataType = typeof(Int32);

                Style s = new Style(typeof(XamNumericEditor));
                Binding b = new Binding();
                RelativeSource rs = new RelativeSource();
                rs.AncestorType = typeof(DataRecordPresenter);
                rs.Mode = RelativeSourceMode.FindAncestor;
                b.RelativeSource = rs;

                b.Path = new PropertyPath(String.Format("DataRecord.DataItem.Periods[{0}].Status", i));
                DataTrigger dt = new DataTrigger() { Binding = b, Value = 0, };
                dt.Setters.Add(new Setter(XamNumericEditor.BackgroundProperty, Brushes.Red));
                s.Triggers.Add(dt);

                DataTrigger dt1 = new DataTrigger() { Binding = b, Value = 1, };
                dt1.Setters.Add(new Setter(XamNumericEditor.BackgroundProperty, Brushes.Green));
                s.Triggers.Add(dt1);

                s.Setters.Add(new Setter(XamNumericEditor.ToolTipProperty, b));

                field.Settings.EditorStyle = s;
                e.FieldLayout.Fields.Add(field);
            }
        }
    }

    public class MyConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (value is Period)
            {
                return (value as Period).Hours;
            }
            return Binding.DoNothing;
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (value is Period)
            {
                return (value as Period);
            }
            return Binding.DoNothing;
        }
    }

}
